import React, { useRef } from 'react';
import { useClouds, useCloud } from './use-cloud';
export var DarkCloud = function DarkCloud(_ref) {
  var value = _ref.value;
  var cloud = useRef();
  useCloud(cloud);
  return React.createElement("mesh", {
    ref: cloud,
    position: value.startpoint
  }, React.createElement("circleBufferGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), React.createElement("meshBasicMaterial", {
    attach: "material",
    transparent: true,
    opacity: value.opacity,
    color: value.color
  }));
};

var Cloudy = function Cloudy(props) {
  var _useClouds = useClouds(props),
      clouds = _useClouds.clouds;

  return React.createElement(React.Fragment, null, clouds.map(function (cloud, index) {
    return React.createElement(DarkCloud, {
      key: index,
      value: cloud
    });
  }));
};

export default Cloudy;
//# sourceMappingURL=index.js.map
