function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useEffect, useState } from 'react';
import { useThree } from 'react-three-fiber';
import { PerspectiveCamera } from 'drei';
import { Color, Object3D, MeshPhysicalMaterial, Vector3, Fog as _Fog, Euler } from 'three';
import { OBJLoader } from 'three/examples/jsm/loaders/OBJLoader';
var url = 'https://raw.githubusercontent.com/iondrimba/images/master/buildings.obj';
var loader = new OBJLoader();

var CityFog = function CityFog() {
  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      buildings = _useState2[0],
      setBuildings = _useState2[1];

  var _useThree = useThree(),
      scene = _useThree.scene;

  useEffect(function () {
    loader.load(url, function (obj) {
      obj.castShadow = true;
      obj.receiveShadow = true;

      var models = _toConsumableArray(obj.children).map(function (model) {
        var scale = 0.01;
        model.scale.set(scale, scale, scale);
        model.receiveShadow = true;
        model.castShadow = true;
        return model;
      });

      var boxSize = 3;
      var meshParams = {
        metalness: 0,
        roughness: 0.77
      };
      var max = 0.009;
      var min = 0.001;
      var material = new MeshPhysicalMaterial(Object.assign(Object.assign({}, meshParams), {
        transparent: true
      }));
      var buildings = new Object3D();
      var gridSize = 40;

      for (var i = 0; i < gridSize; i++) {
        for (var j = 0; j < gridSize; j++) {
          var model = models[Math.floor(Math.random() * Math.floor(models.length))].clone();
          model.material = material;
          model.scale.y = Math.random() * (max - min + 0.01);
          model.position.x = i * boxSize;
          model.position.z = j * boxSize;
          buildings.add(model);
        }
      }

      buildings.castShadow = true;
      buildings.receiveShadow = true;
      setBuildings(buildings);
      var near = 1;
      var far = 208;
      var color = '#353c3c';
      scene.fog = new _Fog(color, near, far);
      scene.background = new Color(color);
    });
  }, [scene]);
  return React.createElement("mesh", null, buildings ? React.createElement("primitive", {
    castShadow: true,
    receiveShadow: true,
    object: buildings,
    dispose: null
  }) : null);
};

var rotation = [-0.4239391588266323, 0.7010640463834621, 0.2832774959276831];
var position = [127.45293777867074, 62.11080512264083, 137.6247069251716];

var Camera = function Camera() {
  return React.createElement(PerspectiveCamera, {
    rotation: _construct(Euler, rotation),
    position: _construct(Vector3, position),
    children: null,
    makeDefault: true,
    args: [20, 2, 1, 1000]
  });
};

var Fog = function Fog() {
  return React.createElement(React.Fragment, null, React.createElement(Camera, null), React.createElement(CityFog, null), React.createElement("directionalLight", {
    position: [-8, 12, 0],
    castShadow: true,
    color: "#272727"
  }), React.createElement("directionalLight", {
    position: [8, 1200, 8],
    color: "#d3263a",
    castShadow: true
  }), React.createElement("mesh", {
    rotation: [0, 0, -Math.PI / 2],
    position: [0, 10, -150]
  }, React.createElement("planeBufferGeometry", {
    attach: "geometry",
    args: [400, 100]
  }), React.createElement("meshPhysicalMaterial", {
    attach: "material",
    color: "#fff"
  })), React.createElement("mesh", {
    castShadow: true,
    receiveShadow: true,
    rotation: [-Math.PI / 2, 0, 0],
    position: [50, 0, 50]
  }, React.createElement("planeBufferGeometry", {
    attach: "geometry",
    args: [100, 100, 10, 10]
  }), React.createElement("meshPhysicalMaterial", {
    attach: "material",
    color: "#353c3c"
  })));
};

export default Fog;
//# sourceMappingURL=index.js.map
