import React, { useRef } from 'react';
import { useHazeDrop, useHaze } from './use-haze';
export var SKY_COLOR = '#A2915E';
export var Haze = function Haze(props) {
  var haze = useRef();
  var mat = useRef();
  useHazeDrop(haze, mat, {
    value: props.value
  });
  return React.createElement(React.Fragment, null, React.createElement("mesh", {
    ref: haze
  }, React.createElement("meshLine", {
    attach: "geometry",
    vertices: props.value.vertices
  }), React.createElement("meshLineMaterial", {
    attach: "material",
    ref: mat,
    transparent: true,
    depthTest: false,
    sizeAttenuation: true,
    lineWidth: 0.01,
    dashArray: props.value.dashArray,
    dashRatio: 0.8,
    opacity: props.value.opacity,
    color: props.value.color
  })));
};

var Hazes = function Hazes(props) {
  var _useHaze = useHaze(props),
      lines = _useHaze.lines;

  return React.createElement(React.Fragment, null, lines.map(function (haze, index) {
    return React.createElement(Haze, {
      key: index,
      value: haze
    });
  }));
};

export default Hazes;
//# sourceMappingURL=index.js.map
