import React, { useRef } from 'react';
import { useMeteors, useMeteor } from './use-metors';

var Meteor = function Meteor(_ref) {
  var value = _ref.value;
  var meteor = useRef();
  var mat = useRef();
  useMeteor(meteor, mat, {
    value: value
  });
  return React.createElement("mesh", {
    ref: meteor
  }, React.createElement("meshLine", {
    attach: "geometry",
    vertices: value.vertices
  }), React.createElement("meshLineMaterial", {
    attach: "material",
    ref: mat,
    transparent: true,
    depthTest: false,
    sizeAttenuation: true,
    lineWidth: 0.02,
    dashArray: 0.5,
    dashRatio: 0.7,
    opacity: 0.75,
    color: value.color
  }));
};

var Meteors = function Meteors(props) {
  var _useMeteors = useMeteors(props),
      meteors = _useMeteors.meteors;

  return React.createElement(React.Fragment, null, meteors.map(function (meteor, index) {
    return React.createElement(Meteor, {
      key: index,
      value: meteor
    });
  }));
};

export default Meteors;
//# sourceMappingURL=index.js.map
