import React, { useRef } from 'react';
import { usePartlyClouds, usePartlyCloud } from './use-partly-cloud';
export var WhiteCloud = function WhiteCloud(_ref) {
  var value = _ref.value;
  var cloud = useRef();
  usePartlyCloud(cloud);
  return React.createElement("mesh", {
    ref: cloud,
    position: value.startpoint
  }, React.createElement("circleBufferGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), React.createElement("meshBasicMaterial", {
    attach: "material",
    transparent: true,
    opacity: value.opacity,
    color: value.color
  }));
};

var PartlyCloudy = function PartlyCloudy(props) {
  var _usePartlyClouds = usePartlyClouds(props),
      clouds = _usePartlyClouds.clouds;

  return React.createElement(React.Fragment, null, clouds.map(function (cloud, index) {
    return React.createElement(WhiteCloud, {
      key: index,
      value: cloud
    });
  }));
};

export default PartlyCloudy;
//# sourceMappingURL=index.js.map
