import React, { useRef } from 'react';
import { useRainRing, useRainRings } from './use-rain-ring';
export var RainRing = function RainRing(_ref) {
  var value = _ref.value;
  var mesh = useRef();
  useRainRing(mesh);
  return React.createElement("mesh", {
    ref: mesh,
    scale: [0, 0, 0],
    position: value.startpoint
  }, React.createElement("circleGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), React.createElement("meshBasicMaterial", {
    attach: "material",
    opacity: 0.2,
    transparent: true,
    color: "white"
  }));
};

var RainRings = function RainRings(props) {
  var _useRainRings = useRainRings(props),
      rings = _useRainRings.rings;

  return React.createElement(React.Fragment, null, rings.map(function (ring, index) {
    return React.createElement(RainRing, {
      key: index,
      value: ring
    });
  }));
};

export default RainRings;
//# sourceMappingURL=index.js.map
