import React, { useRef } from 'react';
import { useRain, useRaindrop } from './use-rain';
export var SKY_COLOR = '#1677b3';
export var Raindrop = function Raindrop(props) {
  var raindrop = useRef();
  var mat = useRef();
  useRaindrop(raindrop, mat, {
    value: props.value
  });
  return React.createElement(React.Fragment, null, React.createElement("mesh", {
    ref: raindrop
  }, React.createElement("meshLine", {
    attach: "geometry",
    vertices: props.value.vertices
  }), React.createElement("meshLineMaterial", {
    attach: "material",
    ref: mat,
    transparent: true,
    depthTest: false,
    sizeAttenuation: true,
    lineWidth: 0.01,
    opacity: 0,
    color: props.value.color
  })));
};

var Rain = function Rain(props) {
  var _useRain = useRain(props),
      lines = _useRain.lines;

  return React.createElement(React.Fragment, null, lines.map(function (raindrop, index) {
    return React.createElement(Raindrop, {
      key: index,
      value: raindrop
    });
  }));
};

export default Rain;
//# sourceMappingURL=index.js.map
