import React, { useRef } from 'react';
import { useSnowflakes, useSnowflake } from './use-snowflake';

var SnowFlake = function SnowFlake(_ref) {
  var value = _ref.value;
  var flake = useRef();
  useSnowflake(flake, {
    value: value
  });
  return React.createElement("mesh", {
    position: value.startpoint,
    ref: flake
  }, React.createElement("circleGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), React.createElement("meshBasicMaterial", {
    color: "white",
    attach: "material"
  }));
};

var Snow = function Snow(props) {
  var _useSnowflakes = useSnowflakes(props),
      snowflakes = _useSnowflakes.snowflakes;

  return React.createElement(React.Fragment, null, snowflakes.map(function (snowflake, index) {
    return React.createElement(SnowFlake, {
      key: index,
      value: snowflake
    });
  }));
};

export default Snow;
//# sourceMappingURL=index.js.map
