import React, { useRef } from 'react';
import { useStarRings, useRing } from './use-starrings';

var Ring = function Ring(_ref) {
  var value = _ref.value;
  var ring = useRef();
  useRing(ring);
  return React.createElement("mesh", null, React.createElement("meshLine", {
    attach: "geometry",
    vertices: value.vertices
  }), React.createElement("meshLineMaterial", {
    ref: ring,
    attach: "material",
    transparent: true,
    depthTest: false,
    sizeAttenuation: true,
    dashArray: value.dashArray,
    dashRatio: 0.2,
    lineWidth: value.lineWidth,
    opacity: value.opacity,
    color: value.color
  }));
};

var StarRings = function StarRings(props) {
  var _useStarRings = useStarRings(props),
      rings = _useStarRings.rings;

  return React.createElement(React.Fragment, null, rings.map(function (ring, index) {
    return React.createElement(Ring, {
      key: index,
      value: ring
    });
  }));
};

export default StarRings;
//# sourceMappingURL=index.js.map
