import React, { useRef } from 'react';
import { useFrame } from 'react-three-fiber';
import { useSun } from './use-sun';
import { inRange } from '../utils/random';
import { DIRS } from '../utils/constants';
export var SKY_COLOR = '#faf4e8';

var SunHalo = function SunHalo(_ref) {
  var value = _ref.value;
  var dir = useRef(1);
  var speed = useRef(Math.random() * 0.0001 * inRange(DIRS));
  var halo = useRef();
  useFrame(function () {
    if (!halo.current) {
      return;
    }

    if (halo.current.scale.x <= 0.9) {
      dir.current = -dir.current;
    } else if (halo.current.scale.x >= 1.1) {
      dir.current = -dir.current;
    }

    halo.current.scale.x += speed.current * dir.current;
    halo.current.scale.y += speed.current * dir.current;
  });
  return React.createElement("mesh", {
    ref: halo,
    position: value.startpoint
  }, React.createElement("circleGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), React.createElement("meshBasicMaterial", {
    attach: "material",
    color: value.color
  }));
};

var Sun = function Sun(props) {
  var sun = useRef();

  var _useSun = useSun(props),
      halos = _useSun.halos,
      startpoint = _useSun.startpoint;

  return React.createElement("group", {
    ref: sun,
    position: startpoint
  }, halos.map(function (halo, index) {
    return React.createElement(SunHalo, {
      key: index,
      value: halo
    });
  }));
};

export default Sun;
//# sourceMappingURL=index.js.map
