"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.RainRing = void 0;

var _react = _interopRequireWildcard(require("react"));

var _useRainRing = require("./use-rain-ring");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var RainRing = function RainRing(_ref) {
  var value = _ref.value;
  var mesh = (0, _react.useRef)();
  (0, _useRainRing.useRainRing)(mesh);
  return _react.default.createElement("mesh", {
    ref: mesh,
    scale: [0, 0, 0],
    position: value.startpoint
  }, _react.default.createElement("circleGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), _react.default.createElement("meshBasicMaterial", {
    attach: "material",
    opacity: 0.2,
    transparent: true,
    color: "white"
  }));
};

exports.RainRing = RainRing;

var RainRings = function RainRings(props) {
  var _useRainRings = (0, _useRainRing.useRainRings)(props),
      rings = _useRainRings.rings;

  return _react.default.createElement(_react.default.Fragment, null, rings.map(function (ring, index) {
    return _react.default.createElement(RainRing, {
      key: index,
      value: ring
    });
  }));
};

var _default = RainRings;
exports.default = _default;
//# sourceMappingURL=index.js.map
