"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _useSnowflake = require("./use-snowflake");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var SnowFlake = function SnowFlake(_ref) {
  var value = _ref.value;
  var flake = (0, _react.useRef)();
  (0, _useSnowflake.useSnowflake)(flake, {
    value: value
  });
  return _react.default.createElement("mesh", {
    position: value.startpoint,
    ref: flake
  }, _react.default.createElement("circleGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), _react.default.createElement("meshBasicMaterial", {
    color: "white",
    attach: "material"
  }));
};

var Snow = function Snow(props) {
  var _useSnowflakes = (0, _useSnowflake.useSnowflakes)(props),
      snowflakes = _useSnowflakes.snowflakes;

  return _react.default.createElement(_react.default.Fragment, null, snowflakes.map(function (snowflake, index) {
    return _react.default.createElement(SnowFlake, {
      key: index,
      value: snowflake
    });
  }));
};

var _default = Snow;
exports.default = _default;
//# sourceMappingURL=index.js.map
