"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SKY_COLOR = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactThreeFiber = require("react-three-fiber");

var _useSun2 = require("./use-sun");

var _random = require("../utils/random");

var _constants = require("../utils/constants");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var SKY_COLOR = '#faf4e8';
exports.SKY_COLOR = SKY_COLOR;

var SunHalo = function SunHalo(_ref) {
  var value = _ref.value;
  var dir = (0, _react.useRef)(1);
  var speed = (0, _react.useRef)(Math.random() * 0.0001 * (0, _random.inRange)(_constants.DIRS));
  var halo = (0, _react.useRef)();
  (0, _reactThreeFiber.useFrame)(function () {
    if (!halo.current) {
      return;
    }

    if (halo.current.scale.x <= 0.9) {
      dir.current = -dir.current;
    } else if (halo.current.scale.x >= 1.1) {
      dir.current = -dir.current;
    }

    halo.current.scale.x += speed.current * dir.current;
    halo.current.scale.y += speed.current * dir.current;
  });
  return _react.default.createElement("mesh", {
    ref: halo,
    position: value.startpoint
  }, _react.default.createElement("circleGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), _react.default.createElement("meshBasicMaterial", {
    attach: "material",
    color: value.color
  }));
};

var Sun = function Sun(props) {
  var sun = (0, _react.useRef)();

  var _useSun = (0, _useSun2.useSun)(props),
      halos = _useSun.halos,
      startpoint = _useSun.startpoint;

  return _react.default.createElement("group", {
    ref: sun,
    position: startpoint
  }, halos.map(function (halo, index) {
    return _react.default.createElement(SunHalo, {
      key: index,
      value: halo
    });
  }));
};

var _default = Sun;
exports.default = _default;
//# sourceMappingURL=index.js.map
